%     This file is part of correlation_gui.
% 
%     correlation_gui is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     any later version.
% 
%     correlation_gui is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with correlation_gui.  If not, see <http://www.gnu.org/licenses/>.
% 
%     Diese Datei ist Teil von correlation_gui.
% 
%     correlation_gui ist Freie Software: Sie knnen es unter den Bedingungen
%     der GNU General Public License, wie von der Free Software Foundation,
%     Version 3 der Lizenz oder jeder neueren verffentlichten Version, 
%     weiter verteilen und/oder modifizieren.
% 
%     correlation_gui wird in der Hoffnung, dass es ntzlich sein wird, aber
%     OHNE JEDE GEWHRLEISTUNG, bereitgestellt; sogar ohne die implizite
%     Gewhrleistung der MARKTFHIGKEIT oder EIGNUNG FR EINEN BESTIMMTEN ZWECK.
%     Siehe die GNU General Public License fr weitere Details.
% 
%     Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
%     Programm erhalten haben. Wenn nicht, siehe <https://www.gnu.org/licenses/>.
    
function varargout = correlation_gui(varargin)
% CORRELATION_GUI MATLAB code for correlation_gui.fig
%      CORRELATION_GUI, by itself, creates a new CORRELATION_GUI or raises the existing
%      singleton*.
%
%      H = CORRELATION_GUI returns the handle to a new CORRELATION_GUI or the handle to
%      the existing singleton*.
%
%      CORRELATION_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CORRELATION_GUI.M with the given input arguments.
%
%      CORRELATION_GUI('Property','Value',...) creates a new CORRELATION_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before correlation_gui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to correlation_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help correlation_gui

% Last Modified by GUIDE v2.5 19-Aug-2015 18:46:54

% 2019-03-05 16:27:37 +0100, Albrecht Petzold, (HEAD -> Matlab2012, tag: v1.1) [fix] set C1 as free parameter by default when loading new data
% 2019-03-05 12:11:19 +0100, Albrecht Petzold, [fix] owered fitting tolerance, increased number of iterations for fit
% 2019-03-05 12:05:42 +0100, Albrecht Petzold, [feature] Calculation of Invariant Q including saving in results file
% 2019-02-21 17:10:18 +0100, Albrecht Petzold, [feature] tried on smart x-limits for Is^2. Not yet working as expected.
% 2019-02-21 15:29:36 +0100, Albrecht Petzold, [feature] pretty print axis titles including the name of the shown properties
% 2019-02-21 15:03:54 +0100, Albrecht Petzold, [feature] changes tab order to be reasonable
% 2019-02-21 14:54:34 +0100, Albrecht Petzold, [feature] input fields can now be used with comma or dot as decimal separator
% 2019-02-21 14:29:29 +0100, Albrecht Petzold, [feature] combined functions for edit_startValueP1..4_callback
% 2019-02-21 14:00:40 +0100, Albrecht Petzold, [editor] removed warning messages due to unused variables as well as unused functions (can't be checked by Matlab for GUI programs anyway).
% 2019-02-21 13:42:55 +0100, Albrecht Petzold, [fix] removed too tight x-limits for P-Is4 plot TODO: find some smart way to set plot range
% 2019-02-21 13:41:53 +0100, Albrecht Petzold, [fix] Porod fitting range selection now independent of beam stop cut off
% 2018-10-08 11:48:43 +0200, Albrecht Petzold, Added .gitignore. Ignore files autosaved by Matlab IDE
% 2018-10-01 09:56:18 +0200, Albrecht Petzold, Initial commit, final version August 2015

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @correlation_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @correlation_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before correlation_gui is made visible.
function correlation_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to correlation_gui (see VARARGIN)

% Choose default command line output for correlation_gui
handles.output = hObject;

movegui(gcf,'center')

% UIWAIT makes correlation_gui wait for user response (see UIRESUME)
% Update handles structure
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = correlation_gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --------------------------------------------------------------------
function Menu_File_Callback(hObject, eventdata, handles) %#ok<*INUSD>
% hObject    handle to Menu_File (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_openStandardFile_Callback(hObject, eventdata, handles)
% hObject    handle to menu_openStandardFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% open GUI to select data file
% if another data file had been opened before, open the path of that data
% file
if ( isfield(handles,'pathName') )
    [handles.fileName,handles.pathName] = uigetfile('*.phg',...
        'Load phg-File',handles.pathName );
else
    [handles.fileName,handles.pathName] = uigetfile('*.phg','Load phg-File');
end
% check whether user has selected 'cancel' in the GUI, if yes end function 
if isequal(handles.fileName,0) || isequal(handles.pathName,0)
   return
end

% Update handles structure (to save file path)
guidata(hObject, handles);

try
    % Extract the scatter vectors, the corresponding absolute intensities
    % and errors from the specified file
    [handles.scattVect, handles.absInt,  handles.desmearedError] ...
        = loadStandardFile(handles.fileName,handles.pathName);
catch ME
    switch ME.identifier
        case 'errMsg:FileEmpty'
            errdlg('The selected data file is empty!');
        case 'errMsg:wrongFormat'
            errordlg('The selected data file does not have the required format!',...
            'data error')
        otherwise
            errordlg('An error occured. Please select a new file!');
    end
    % delete previously calculated results 
    handles = deleteResults(handles,'data'); 
    return
end


% if another data set had been loaded before, delete the calculated results
% for that data set and disable buttons/boxes
if( strcmp(get(handles.pb_plot_absInt,'Enable') , 'on') )
    handles = deleteResults(handles, 'data');
    clear handles.indexBeamStop;
    set(handles.edit_beamStop, 'String', num2str(0));
else
    set(handles.pb_plot_absInt, 'Enable', 'on')
end
% display the name of the data file in the corresponding panel
set(handles.text_dataFileName, 'String', handles.fileName)
% Update handles structure
guidata(hObject, handles);
try
    % plot absolute intensities
    pb_plot_absInt_Callback(hObject, eventdata, handles)
catch ME %#ok<*NASGU>
    errordlg(['The data contains only negative values for the absolute '...
                'intensities. Please select a new file!']);
    % delete previously calculated results 
    handles = deleteResults(handles,'data'); %#ok<NASGU>
    return
end


% --------------------------------------------------------------------
function menu_openCostumFile_Callback(hObject, eventdata, handles)
% hObject    handle to menu_openCostumFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% open GUI to select data file
% if another data file had been opened before, open the path of that data
% file
if ( isfield(handles,'pathName') )
    [handles.fileName,handles.pathName] = uigetfile('*.*',...
        'Load customized file',handles.pathName );
else
    [handles.fileName,handles.pathName] = uigetfile('*.*','Load customized file');
end

% check whether user has selected 'cancel' in the GUI, if yes end function 
if isequal(handles.fileName,0) || isequal(handles.pathName,0)
   return
end

% Update handles structure (to save file path)
guidata(hObject, handles);

% open GUI to specify the file details (number of header lines; delimiter
% between columns; column number for scatter vectors, absolute intensities
% and desmeared error (optional)
try
    fileDetails = fileProperties_gui;
catch ME
    errordlg('An error occured. Please select a new file!');
    % delete previously calculated results 
    handles = deleteResults(handles,'data'); %#ok<NASGU>
    return
end

% Extract the scatter vectors, the corresponding absolute intensities
% and errors from the specified file
try
    [handles.scattVect, handles.absInt,  handles.desmearedError] ...
        = loadCustomFile(handles.fileName,handles.pathName,...
            fileDetails.nHeaderLines, fileDetails.delimiter, ...
            fileDetails.scattVectType, fileDetails.scattVectUnit, ...
            fileDetails.colScattVect, fileDetails.colAbsInt, ...
            fileDetails.colError);
catch ME
    errordlg('An error occured. Please select a new file!');
    % delete previously calculated results 
    handles = deleteResults(handles,'data'); %#ok<NASGU>
    return
end

% display the name of the data file in the corresponding panel
set(handles.text_dataFileName, 'String', handles.fileName)
% if another data set had been loaded before, delete the calculated results
% for that data set and disable buttons/boxes
if( strcmp(get(handles.pb_plot_absInt,'Enable') , 'on') )
    handles = deleteResults(handles, 'data');
    clear handles.indexBeamStop;
    set(handles.edit_beamStop, 'String', num2str(0));
else
    set(handles.pb_plot_absInt, 'Enable', 'on')
end
% Update handles structure
guidata(hObject, handles);
try
    % plot absolute intensities
    pb_plot_absInt_Callback(hObject, eventdata, handles)
catch ME
    errordlg(['The data contains only negative values for the absolute '...
                'intensities. Please select a new file!']);
    % delete previously calculated results 
    handles = deleteResults(handles,'data');
    return
end
    

% --- Executes on button press in pb_plot_absInt.
function pb_plot_absInt_Callback(hObject, eventdata, handles)
% hObject    handle to pb_plot_absInt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% first data points up to the first one with positive intensity are discarded
if ( isempty(find((handles.absInt<=0), 1, 'last')) ) %no negative intensity
    handles.indexBeamStopMin = 0;
else
    handles.indexBeamStopMin = find((handles.absInt>0), 1, 'first')-1;
end
% if the determined index of the last data point with negative intensity is
% higher than the index of the beam stop cut off specified by the user,
% than use the determined index for the beam stop cut off and save it in
% the handles structure
if (handles.indexBeamStopMin > str2double(get(handles.edit_beamStop, 'String')))
    set(handles.edit_beamStop, 'String', num2str(handles.indexBeamStopMin));
    handles.indexBeamStop = handles.indexBeamStopMin;
else
    handles.indexBeamStop = str2double(get(handles.edit_beamStop, 'String'));
end
% determine the number of used data points after cut off
handles.numDataUsed = length(handles.scattVect) - handles.indexBeamStop;
set(handles.text_numDataPoints,'String', num2str(handles.numDataUsed));
set(handles.text_totalNumOfDataPoints,'String',...
    num2str(length(handles.scattVect)));
% turn off the warning that negative data is ignored in a log-plot
warning off MATLAB:Axes:NegativeDataInLogAxis
% plot (loglog) the data marking the range of the beam stop cut off in gray
loglog(handles.scattVect(handles.indexBeamStopMin+1:handles.indexBeamStop+1), ...
    handles.absInt(handles.indexBeamStopMin+1:handles.indexBeamStop+1),...
    '.-', 'Color',[.5,.5,.5]);
hold on
loglog(handles.scattVect(handles.indexBeamStop+1:end), ...
    handles.absInt(handles.indexBeamStop+1:end),'k.-');
xlabel('Scattering vector s in nm^{-1}','fontsize',12,'fontweight','b')
ylabel('Absolute intensity I in e.u./nm^3','fontsize',12,'fontweight','b')
xlim([handles.scattVect(handles.indexBeamStopMin+1) handles.scattVect(end)])
handles.absIntPlotYLim = get(gca,'Ylim');

% determin the minimal distance between the scatter vectors (for later use)
handles.minDist = min(diff([0; handles.scattVect]));

% at the first entry, enable the necessary buttons/boxes; 
if ( strcmp(get(handles.edit_minIndexPorodFitRange,'Enable') , 'off') )
    % enable all buttons/editable fields in the beamstop and porodFit panel
    set(findall(handles.panel_beamStop, '-property', 'enable'), 'enable', 'on')
    set(findall(handles.panel_porodFit, '-property', 'enable'), 'enable', 'on')
    % except:
	set(handles.edit_fixedValueP,'Enable','Off');
	set(handles.edit_fixedValueC1,'Enable','Off');
	set(handles.edit_fixedValueC2,'Enable','Off');
	set(handles.cb_fixP,'Value',0);
	set(handles.cb_fixC1,'Value',0);
	set(handles.cb_fixC2,'Value',0);
    % enable other plots
	set(handles.pb_plot_absInt,'Enable','On');
    % set porod fitting range to include only the last data point for now
    set(handles.edit_minIndexPorodFitRange,'String',...
        num2str(length(handles.scattVect)));
    set(handles.edit_maxIndexPorodFitRange,'String',...
        num2str(length(handles.scattVect)));
    set(handles.text_minScattVectPorodFit,'String',...
        num2str(handles.scattVect(end)));
    handles.minScattVectPorod = handles.scattVect(end);
    set(handles.text_maxScattVectPorodFit,'String',...
        num2str(handles.scattVect(end)));
    handles.maxScattVectPorod = handles.scattVect(end);
    % enable save available menu
    set(handles.menu_saveAvailable,'Enable','On');
end
% mark fitting range
minIndex = str2double(get(handles.edit_minIndexPorodFitRange,'String'));
maxIndex = str2double(get(handles.edit_maxIndexPorodFitRange,'String'));
warning off MATLAB:Axes:NegativeDataInLogAxis
loglog(handles.scattVect(minIndex:maxIndex), ...
    handles.absInt(minIndex:maxIndex),'r.-')
hold off

% Update handles structure
guidata(hObject, handles);


function edit_beamStop_Callback(hObject, eventdata, handles)
% hObject    handle to edit_beamStop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% delete previously calculated results if applicable
handles = deleteResults(handles,'PorodFit');

input = str2double(get(hObject,'string'));
if (isnan(input) || input<0 || input>length(handles.absInt) ...
        || input==1i || input ==1j)
    h = errordlg(strcat('You must enter a positive real numeric value ',... 
        ' that is smaller than the total number of data points!'),...
        'Invalid Input', 'modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject) 
    set(handles.edit_beamStop, 'String', num2str(0));
else
    % if a non-interger numerical value was entered round it to the lower integer
    set(handles.edit_beamStop, 'String', num2str(floor(input)));
end
% Update handles structure
guidata(hObject, handles);
% renew the plot; also sets the value of the beam stop cut off to the
% lowest possible value
pb_plot_absInt_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function edit_beamStop_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_beamStop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function text_numDataPoints_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_numDataPoints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% --- Executes during object creation, after setting all properties.
function text_DataPoints_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_DataPoints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in pb_rangePorodFit.
function pb_rangePorodFit_Callback(hObject, eventdata, handles)
% hObject    handle to pb_rangePorodFit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% renew plot of absolute intensities (in which the range is chosen)
pb_plot_absInt_Callback(hObject, eventdata, handles)
% delete previously calculated results if applicable
handles = deleteResults(handles,'PorodFit');
% show pushbutton that is used to terminate the brushing process
set(handles.pb_confirmRange, 'Visible', 'on');
% activate brushing tool
brush on
% block execution until brushed data is confirmed by pressing the
% button pb_confirmRange
waitfor(handles.pb_confirmRange, 'Visible', 'off');
try 
    % determine which data points have been brushed and find lowest and
    % highest index of the brushed data
    hBrushLine = findall(gca,'tag','Brushing');
    brushedData = get(hBrushLine, {'Xdata','Ydata'});
    brushedIdx = ~isnan(brushedData{2,1});
    minIndex = find(brushedIdx,1,'first') + handles.indexBeamStop;
    maxIndex = find(brushedIdx,1,'last') + handles.indexBeamStop;
    % write the min and max index and the corresponding scatter vectors in 
    % the editable text boxes and the handles structure of the GUI
    precision = 4;
    set(handles.edit_minIndexPorodFitRange,'String',num2str(minIndex));
    set(handles.text_minScattVectPorodFit,'String',...
        num2str(handles.scattVect(minIndex),precision));
    set(handles.edit_maxIndexPorodFitRange,'String',num2str(maxIndex));
    set(handles.text_maxScattVectPorodFit,'String',...
        num2str(handles.scattVect(maxIndex),precision));
        handles.minScattVectPorod = handles.scattVect(maxIndex);
    handles.minScattVectPorod = handles.scattVect(minIndex);
    handles.maxScattVectPorod = handles.scattVect(maxIndex);
    brush off
    % renew the plot
    pb_plot_absInt_Callback(hObject, eventdata, handles)
catch ME
    brush off
    return
end
% Update handles structure
guidata(hObject, handles); 

% --- Executes on button press in pb_confirmRange.
function pb_confirmRange_Callback(hObject, eventdata, handles)
% hObject    handle to pb_confirmRange (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.pb_confirmRange, 'Visible', 'off');
% Update handles structure
guidata(hObject, handles); 

function edit_minIndexPorodFitRange_Callback(hObject, eventdata, handles)
% hObject    handle to edit_minIndexPorodFitRange (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% delete previously calculated results if applicable
handles = deleteResults(handles,'PorodFit');

minIndex = str2double(get(handles.edit_minIndexPorodFitRange,'String'));
maxIndex = str2double(get(handles.edit_maxIndexPorodFitRange,'String'));
precision = 4;
% check validity of input values
if ( isnan(minIndex) || minIndex==1i || minIndex ==1j ||...
    minIndex <= str2double(get(handles.edit_beamStop,'String')) )
    h = errordlg(['You must enter a positive real numeric value that is '...
        'greater than the beam stop cut off!'],...
        'Invalid Input Porod fit range','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % replace invalid input value by the value of the upper index
    set(handles.edit_minIndexPorodFitRange,'String',num2str(maxIndex));
    set(handles.text_minScattVectPorodFit,'String',...
    num2str(handles.scattVect(maxIndex),precision));
    handles.minScattVectPorod = handles.scattVect(maxIndex);
elseif (minIndex > maxIndex)
    h = errordlg('The left index cannot be greater than the right index!',...
        'Invalid Input Porod fit range','modal');
    uiwait(h)% wait until error dialog is closed, then continue)
    uicontrol(hObject)
    % replace invalid input value by the value of the upper index
    set(handles.edit_minIndexPorodFitRange,'String',num2str(maxIndex));
    set(handles.text_minScattVectPorodFit,'String',...
    num2str(handles.scattVect(maxIndex),precision));
    handles.minScattVectPorod = handles.scattVect(maxIndex);
else
    minIndex = floor(minIndex);
    set(handles.edit_minIndexPorodFitRange, 'String', num2str(minIndex));
    set(handles.text_minScattVectPorodFit,'String',...
        num2str(handles.scattVect(minIndex),precision));
    handles.minScattVectPorod = handles.scattVect(minIndex);
end
% Update handles structure
guidata(hObject, handles);
% renew plot of absolute intensity (and mark fitting range)
pb_plot_absInt_Callback(hObject, eventdata, handles)

function edit_maxIndexPorodFitRange_Callback(hObject, eventdata, handles)
% hObject    handle to edit_maxIndexPorodFitRange (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% delete previously calculated results if applicable
handles = deleteResults(handles,'PorodFit');

minIndex = str2double(get(handles.edit_minIndexPorodFitRange,'String'));
maxIndex = str2double(get(handles.edit_maxIndexPorodFitRange,'String'));
precision = 4;
% check validity of input values
if ( isnan(maxIndex) || maxIndex==1i || maxIndex ==1j ||...
    maxIndex > str2double(get(handles.text_totalNumOfDataPoints,'String')) )
    h = errordlg(['You must enter a positive real numeric value that is not'...
        ' greater than the total number of data points!'],...
        'Invalid Input Porod fit range','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % replace invalid input value by the value of the lower index
    set(handles.edit_maxIndexPorodFitRange,'String',num2str(minIndex));
    set(handles.text_maxScattVectPorodFit,'String',...
    num2str(handles.scattVect(minIndex),precision));
    handles.maxScattVectPorod = handles.scattVect(minIndex);
elseif (minIndex > maxIndex)
    h = errordlg('The left index cannot be greater than the right index!',...
        'Invalid Input Porod fit range','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % replace invalid input value by the value of the lower index
    set(handles.edit_maxIndexPorodFitRange,'String',num2str(minIndex));
    set(handles.text_maxScattVectPorodFit,'String',...
    num2str(handles.scattVect(minIndex),precision));
    handles.maxScattVectPorod = handles.scattVect(minIndex);
else
    maxIndex = floor(maxIndex);
    set(handles.edit_maxIndexPorodFitRange, 'String', num2str(maxIndex));
    set(handles.text_maxScattVectPorodFit,'String',...
        num2str(handles.scattVect(maxIndex),precision));
    handles.maxScattVectPorod = handles.scattVect(maxIndex);
end
% Update handles structure
guidata(hObject, handles);
% renew plot of absolute intensity (and mark fitting range)
pb_plot_absInt_Callback(hObject, eventdata, handles)

% --- Executes on key press with focus on edit_maxIndexPorodFitRange and none of its controls.
function edit_maxIndexPorodFitRange_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_maxIndexPorodFitRange (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
% --- Executes on key press with focus on edit_minIndexPorodFitRange and none of its controls.
function edit_minIndexPorodFitRange_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_minIndexPorodFitRange (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)


function edit_startValueP1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_startValueP1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

edit_startValueP(hObject, eventdata, handles);

% --- Executes during object creation, after setting all properties.
function edit_startValueP1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_startValueP1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_startValueP2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_startValueP2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

edit_startValueP(hObject, eventdata, handles);

% --- Executes during object creation, after setting all properties.
function edit_startValueP2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_startValueP2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_startValueP3_Callback(hObject, eventdata, handles)
% hObject    handle to edit_startValueP3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

edit_startValueP(hObject, eventdata, handles);

% --- Executes during object creation, after setting all properties.
function edit_startValueP3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_startValueP3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_startValueP4_Callback(hObject, eventdata, handles)
% hObject    handle to edit_startValueP4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

edit_startValueP(hObject, eventdata, handles);

% --- Executes during object creation, after setting all properties.
function edit_startValueP4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_startValueP4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_startValueP(hObject, eventdata, handles)
% hObject    handle to edit_startValueP1...4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% delete previously calculated results if applicable
handles = deleteResults(handles,'PorodFit');

% get all current starting values
sValP1 = str2double(strrep(get(handles.edit_startValueP1,'string'), ',', '.'));
sValP2 = str2double(strrep(get(handles.edit_startValueP2,'string'), ',', '.'));
sValP3 = str2double(strrep(get(handles.edit_startValueP3,'string'), ',', '.'));
sValP4 = str2double(strrep(get(handles.edit_startValueP4,'string'), ',', '.'));
% write corrected values back to GUI
set(handles.edit_startValueP1, 'string', num2str(sValP1));
set(handles.edit_startValueP2, 'string', num2str(sValP2));
set(handles.edit_startValueP3, 'string', num2str(sValP3));
set(handles.edit_startValueP4, 'string', num2str(sValP4));
% verify that startValueP1 is: numeric, positive and distinct from other 
% starting values
notDistinct = (length(unique([sValP1 sValP2 sValP3 sValP4]))<4);
if (isnan(sValP4) || sValP4<0 || notDistinct || sValP4==1i || sValP4 ==1j)
    h = errordlg('The starting values must be distinct positive real numeric values!'...
        ,'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % replace the invalid value by an unused element of the default values
    % [0.2 0.4 0.6 0.8])
    unusedDefault = setdiff([.2 .4 .6 .8],[sValP1 sValP2 sValP3 sValP4]);
    set(hObject, 'String', num2str(unusedDefault(1)));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in cb_fixP.
function cb_fixP_Callback(hObject, eventdata, handles)
% hObject    handle to cb_fixP (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% delete previously calculated results if applicable
handles = deleteResults(handles,'PorodFit');

% Hint: get(hObject,'Value') returns toggle state of cb_fixP
if (get(hObject,'Value') == get(hObject,'Max')) % checkbox is checked
	set(handles.edit_fixedValueP,'Enable','on');
	set(handles.edit_startValueP1,'Enable','off');
	set(handles.edit_startValueP2,'Enable','off');
	set(handles.edit_startValueP3,'Enable','off');
	set(handles.edit_startValueP4,'Enable','off');
else
	set(handles.edit_fixedValueP,'Enable','off');
	set(handles.edit_startValueP1,'Enable','on');
	set(handles.edit_startValueP2,'Enable','on');
	set(handles.edit_startValueP3,'Enable','on');
	set(handles.edit_startValueP4,'Enable','on');
end

function edit_fixedValueP_Callback(hObject, eventdata, handles)
% hObject    handle to edit_fixedValueP (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% delete previously calculated results if applicable
handles = deleteResults(handles,'PorodFit');

input = str2double(strrep(get(hObject,'string'), ',', '.'));
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg('You must enter a positive real numeric value',...
        'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    set(handles.edit_fixedValueP, 'String', num2str(0.2));
else
    set(hObject, 'string', num2str(input));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_fixedValueP_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_fixedValueP (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in cb_fixC1.
function cb_fixC1_Callback(hObject, eventdata, handles)
% hObject    handle to cb_fixC1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of cb_fixC1

% delete previously calculated results if applicable
handles = deleteResults(handles,'PorodFit');

if (get(hObject,'Value') == get(hObject,'Max')) % checkbox is checked
	set(handles.edit_fixedValueC1,'Enable','on');
else
	set(handles.edit_fixedValueC1,'Enable','off');
end

function edit_fixedValueC1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_fixedValueC1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% delete previously calculated results if applicable
handles = deleteResults(handles,'PorodFit');

input = str2double(strrep(get(hObject,'string'), ',', '.'));
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg('You must enter a positive real numeric value',...
        'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    set(handles.edit_fixedValueC1, 'String', num2str(0));
else
    set(hObject, 'string', num2str(input));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_fixedValueC1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_fixedValueC1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in cb_fixC2.
function cb_fixC2_Callback(hObject, eventdata, handles)
% hObject    handle to cb_fixC2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of cb_fixC2

% delete previously calculated results if applicable
handles = deleteResults(handles,'PorodFit');

if (get(hObject,'Value') == get(hObject,'Max')) % checkbox is checked
	set(handles.edit_fixedValueC2,'Enable','on');
else
	set(handles.edit_fixedValueC2,'Enable','off');
end

function edit_fixedValueC2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_fixedValueC2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% delete previously calculated results if applicable
handles = deleteResults(handles,'PorodFit');

input = str2double(strrep(get(hObject,'string'), ',', '.'));
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg('You must enter a positive real numeric value',...
        'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    set(handles.edit_fixedValueC2, 'String', num2str(600));
else
    set(hObject, 'string', num2str(input));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_fixedValueC2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_fixedValueC2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_widthOfWindowFcn_Callback(hObject, eventdata, handles) %#ok<*INUSL,*DEFNU>
% hObject    handle to edit_widthOfWindowFcn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% delete previously calculated results if applicable
handles = deleteResults(handles,'PorodFit');

input = str2double(strrep(get(hObject,'string'), ',', '.'));
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg('You must enter a positive real numeric value',...
        'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % set width to default value
    set(handles.edit_widthOfWindowFcn, 'string', num2str(1.6));
else
    set(hObject, 'string', num2str(input));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_widthOfWindowFcn_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_widthOfWindowFcn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pb_calcPorodFit.
function pb_calcPorodFit_Callback(hObject, eventdata, handles)
% hObject    handle to pb_calcPorodFit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% determine which parameters are fixed and get corresponding values
handles.isFixedP = get(handles.cb_fixP,'Value');
handles.isFixedC1 = get(handles.cb_fixC1,'Value');
handles.isFixedC2 = get(handles.cb_fixC2,'Value');
fixedValueP = str2double(get(handles.edit_fixedValueP,'String'));
sValP1 = str2double(get(handles.edit_startValueP1,'string'));
sValP2 = str2double(get(handles.edit_startValueP2,'string'));
sValP3 = str2double(get(handles.edit_startValueP3,'string'));
sValP4 = str2double(get(handles.edit_startValueP4,'string'));
startValuesP = sort([sValP1 sValP2 sValP3 sValP4]);
fixedValueC1 = str2double(get(handles.edit_fixedValueC1,'String'));
fixedValueC2 = str2double(get(handles.edit_fixedValueC2,'String'));

% index range for PorodFit
minIndex = str2double(get(handles.edit_minIndexPorodFitRange,'String'))...
            - handles.indexBeamStop;
maxIndex = str2double(get(handles.edit_maxIndexPorodFitRange,'String'))...
            - handles.indexBeamStop;
scattVect = handles.scattVect(handles.indexBeamStop+1:end);
absInt= handles.absInt(handles.indexBeamStop+1:end);
handles.sigma = str2double(get(handles.edit_widthOfWindowFcn,'string'));
% perform Porod Fit
[handles.porodFitP, handles.porodFitC1, handles.porodFitC2] =...
        porodFit(scattVect, absInt, minIndex,  maxIndex, handles.sigma,...
        startValuesP,handles.isFixedP, fixedValueP, handles.isFixedC1,...
        fixedValueC1, handles.isFixedC2, fixedValueC2);
handles.K2Zero = calculateK2AtZero(scattVect, absInt, handles.sigma, ...
                handles.porodFitP, handles.porodFitC1, handles.porodFitC2);
% calculate the values of the fitted function and the error norm
handles.porodFit = handles.porodFitP .* scattVect.^(-4)...
    + handles.porodFitC1 .* scattVect.^2 + handles.porodFitC2;
handles.porodFitErrorNorm = sqrt(sum((handles.porodFit(minIndex:maxIndex)...
                            - absInt(minIndex:maxIndex)).^2));

% diplay results in the corresponding panel
isFixedText = {''; '   fixed'};
precision = 12; % number of digits diplayed for each result
result = sprintf([' P = ' num2str(handles.porodFitP,precision)...
        isFixedText{handles.isFixedP+1} '\n c1 = ' ...
        num2str(handles.porodFitC1,precision) isFixedText{handles.isFixedC1+1}...
        '\n c2 = ' num2str(handles.porodFitC2,precision)... 
        isFixedText{handles.isFixedC2+1} '\n K''''(0) = '...
        num2str(handles.K2Zero,precision) ...
        '\n Error norm: || I - I_fit ||_2 = '...
        num2str(handles.porodFitErrorNorm,precision)]);    
set(handles.text_resultsPorodFit,'String', result)
% activate buttons, renew plots, etc. 
set(handles.pb_plot_Is2,'Enable','On');
set(handles.pb_plot_K,'Enable','On');
set(handles.pb_plot_addFit,'Enable', 'on')
set(handles.pb_plot_PIs4,'Enable', 'on')
set(handles.pb_plot_K2,'Enable', 'on')
% add plot of fitted function
pb_plot_addFit_Callback(hObject, eventdata, handles)
% Update handles structure
guidata(hObject, handles);     


% --- Executes on button press in pb_plot_addFit.
function pb_plot_addFit_Callback(hObject, eventdata, handles)
% hObject    handle to pb_plot_addFit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
scattVect = handles.scattVect(handles.indexBeamStop+1:end);

pb_plot_absInt_Callback(hObject, eventdata, handles)
hold on
plot(scattVect,handles.porodFit)
hold off
% set limits of the y-axis to be the same as for the plot of the absolute
% intensities only 
ylim(handles.absIntPlotYLim)



% --- Executes on button press in pb_plot_Is2.
function pb_plot_Is2_Callback(hObject, eventdata, handles)
% hObject    handle to pb_plot_Is2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
brush off;
scattVect = handles.scattVect(handles.indexBeamStop+1:end);
absInt = handles.absInt(handles.indexBeamStop+1:end);
handles.sigma = str2double(get(handles.edit_widthOfWindowFcn, 'String'));

% Calculation of Integrand for invariant:
% The porod parameter P is determined from K''(0) = 0. Hence, the window
% function multiplied to (P-Is^4). So for calculation of Q the window
% function needs also taken into account.
% F(s) = -4*pi*(P - (I(s) - C2)*s^4 + C1*s^6)*exp(-(2*pi*s*sigma)^2) - P)*s^-2
% In the limit of sigma->0 this reduces to I*s^2.
handles.Is2 = -4*pi*((handles.porodFitP ...
        - (absInt - handles.porodFitC2).*scattVect.^4 ...
        + handles.porodFitC1.*scattVect.^6) ...
        .*windowFunction(handles.scattVect(handles.indexBeamStop+1:end), handles.sigma) ...
        - handles.porodFitP).*scattVect.^(-2);

plot(scattVect, handles.Is2,'k.-');   
%loglog(handles.scattVect(handles.indexBeamStop+1:end) , handles.Is2,'k.-',scattVect,4*pi*handles.porodFitP./(scattVect.^2),'b-');   
xlabel('Scattering vector s  in nm^{-1}','fontsize',12,'fontweight','b')
ylabel('4 \pi ((P - (I - c_{2})*s^4 - c_{1}*s^6) exp(- (2 \pi s \sigma)^2) - P)s^-2 in e.u./nm^5',...
    'fontsize',12,'fontweight','b')
% smart x limits
% find the max(y)
% use x(0.001*max(y)) as upper limit
%xlim([0,scattVect(find(handles.Is2<=0.001*max(handles.Is2),1))]);

% calculate invariant Q
% Math: Q = 4 \pi \int\limits_{0}^{\infty} I s^2 exp(-(2 \pi s \sigma)^2)
% Numerics:
% - The lower limit for calculation will be the first data point at s_{min}
% instead of 0 as extrapolation is not (yet) for Is^2
% - The integral is splitted at the last data point s_{max}. The first part
% will be calculated using the data directly while above s_{max} it is
% extended using Porod's law.
% Final function:
% Q = 4 \pi \int\limits_{s_{min}}^{s_{max}} I s^2 ds + 4 \pi P/s_{max} 
Q = trapz(scattVect, handles.Is2);
handles.Q = Q + 4*pi*handles.porodFitP/scattVect(end);

% add the inavriant to the GUI
precision = 12;
results = get(handles.text_resultsPorodFit, 'string');
if ( strcmpi(results(1,1:5), ' Q = ') )
    results = results(2:end,:);
end
results = char(sprintf([' Q = ' num2str(handles.Q, precision) ' e.u./nm^6']), results);
set(handles.text_resultsPorodFit, 'string', results);
% if all results have been calculated, enable save ALL button
if( isfield(handles,'K') && isfield(handles,'transformedModelFcn') )
    set(handles.menu_saveAll,'Enable','on');
end

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in pb_plot_K.
function pb_plot_K_Callback(hObject, eventdata, handles)
% hObject    handle to pb_plot_K (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
brush off;
scattVect = handles.scattVect(handles.indexBeamStop+1:end);
absInt = handles.absInt(handles.indexBeamStop+1:end);
handles.sigma = str2double(get(handles.edit_widthOfWindowFcn, 'String'));
[handles.K, handles.zValues] = calculateK(scattVect, absInt, handles.porodFitC1,...
                                handles.porodFitC2, handles.sigma);
plot(handles.zValues,handles.K,'k.-')
xlabel('Distance z  in  nm','fontsize',12,'fontweight','b')
ylabel('Autocorrelation function K(z)  in  nm^{-6}','fontsize',12,'fontweight','b');
hold on
plot(zeros(1,155))
hold off

% if all results have been calculated, enable save ALL button
if( isfield(handles,'Is2') && isfield(handles,'transformedModelFcn') )
    set(handles.menu_saveAll,'Enable','on');
end

% Update handles structure
guidata(hObject, handles); 

% --- Executes on button press in pb_plot_PIs4.
function pb_plot_PIs4_Callback(hObject, eventdata, handles)
% hObject    handle to pb_plot_PIs4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
scattVect = handles.scattVect(handles.indexBeamStop+1:end);
absInt = handles.absInt(handles.indexBeamStop+1:end);
handles.sigma = str2double(get(handles.edit_widthOfWindowFcn, 'String'));
% Calculate F(s_i) = 16*pi^3*(P - (I(s_i)-c2)*s_i^4 +c1*s_i^6), for s_i \in scatterVector
% Extrapolation to the left: Set F(0) = 16*pi^3*P
% and use linear interpolation to determine 
%           F(s_k), for 0 < s_k < min(s_i | s_i \in scatterVector)          
F = 16*pi^3*(handles.porodFitP - (absInt - handles.porodFitC2)...
                .*scattVect.^4 + handles.porodFitC1*scattVect.^6);
handles.equidistScattVect = (0:handles.minDist:scattVect(end))';
extrapolatedF = interp1([0 scattVect'],  [16*pi^3*handles.porodFitP F'],...
                        handles.equidistScattVect, 'linear');
% Multiply F by the window function wf(s_i) = exp(4*pi^2*sigma^2*s_i^2)
windowFcnValues = windowFunction([handles.equidistScattVect], handles.sigma);
handles.PIs4 = extrapolatedF.*windowFcnValues;

plot(handles.equidistScattVect,zeros(1,length(handles.equidistScattVect)),...
    'b-','LineWidth',.1);
hold on
plot(handles.equidistScattVect,handles.PIs4 ,'k.-')
hold off
xlabel('Scattering vector s in nm^{-1}','fontsize',12,'fontweight','b')
ylabel(['16 \pi^3 (P - (I-c_{2})*s^4 + c_{1}*s^6) exp(- (2 \pi s \sigma)^2)'...
    ' in e.u./nm^7'],'fontsize',12,'fontweight','b');
% set the limits of the x-axis
%set(gca, 'Xlim',[0,0.3]);
% save limits of this plot
handles.PIs4PlotYLim = get(gca, 'Ylim');
handles.PIs4PlotXLim = get(gca, 'Xlim');
% enable all buttons in the panel for the model function fit
set(findall(handles.panel_ModelFunctionFit, '-property', 'enable'), 'enable', 'on')
% Update handles structure
guidata(hObject, handles); 

function pb_plot_K2_Callback(hObject, eventdata, handles)
% hObject    handle to pb_plot_K2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
scattVect = handles.scattVect(handles.indexBeamStop+1:end);
absInt = handles.absInt(handles.indexBeamStop+1:end);
handles.sigma = str2double(get(handles.edit_widthOfWindowFcn, 'String'));
[handles.K2, handles.zValues] = calculateK2(scattVect, absInt, handles.sigma, ...
                handles.porodFitP, handles.porodFitC1, handles.porodFitC2);
plot(handles.zValues,handles.K2,'k.-')
xlabel('Distance z  in  nm','fontsize',12,'fontweight','b')
ylabel('Interface distribution function K''''(z)  in  nm^{-8}','fontsize',12,'fontweight','b');
hold on
plot(zeros(1,floor(handles.zValues(end))))
hold off

% check whether modelFcnFit was already calculated, before enabling addFFTModelFit-button                                 
if( isfield(handles,'modelFcnFit') ) 
    set(handles.pb_addFFTModelFit,'Enable','On')
end
% Update handles structure
guidata(hObject, handles); 


function edit_startValDA_Callback(hObject, eventdata, handles)
% hObject    handle to edit_startValDA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hints: get(hObject,'String') returns contents of edit_startValDA as text
%        str2double(get(hObject,'String')) returns contents of edit_startValDA as a double

% delete previously calculated results if applicable
handles = deleteResults(handles,'ModelFcn');

input = str2double(strrep(get(hObject,'string'), ',', '.'));
default = 8;
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg('You must enter a positive real numeric value',...
        'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % set to default value
    set(hObject, 'string', num2str(default));
else
    set(hObject, 'string', num2str(input));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_startValDA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_startValDA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_startValSigmaA_Callback(hObject, eventdata, handles)
% hObject    handle to edit_startValSigmaA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hints: get(hObject,'String') returns contents of edit_startValSigmaA as text
%        str2double(get(hObject,'String')) returns contents of edit_startValSigmaA as a double

% delete previously calculated results if applicable
handles = deleteResults(handles,'ModelFcn');

input = str2double(strrep(get(hObject,'string'), ',', '.'));
default = 4;
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg('You must enter a positive real numeric value',...
        'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % set to default value
    set(hObject, 'string', num2str(default));
else
    set(hObject, 'string', num2str(input));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_startValSigmaA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_startValSigmaA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_startValDC_Callback(hObject, eventdata, handles)
% hObject    handle to edit_startValDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hints: get(hObject,'String') returns contents of edit_startValDC as text
%        str2double(get(hObject,'String')) returns contents of edit_startValDC as a double

% delete previously calculated results if applicable
handles = deleteResults(handles,'ModelFcn');

input = str2double(strrep(get(hObject,'string'), ',', '.'));
default = 7;
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg('You must enter a positive real numeric value',...
        'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % set to default value
    set(hObject, 'string', num2str(default));
else
    set(hObject, 'string', num2str(input));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_startValDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_startValDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_startValSigmaC_Callback(hObject, eventdata, handles)
% hObject    handle to edit_startValSigmaC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hints: get(hObject,'String') returns contents of edit_startValSigmaC as text
%        str2double(get(hObject,'String')) returns contents of edit_startValSigmaC as a double

% delete previously calculated results if applicable
handles = deleteResults(handles,'ModelFcn');

input = str2double(strrep(get(hObject,'string'), ',', '.'));
default = 1;
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg('You must enter a positive real numeric value',...
        'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % set to default value
    set(hObject, 'string', num2str(default));
else
    set(hObject, 'string', num2str(input));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_startValSigmaC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_startValSigmaC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_lowBoundDA_Callback(hObject, eventdata, handles)
% hObject    handle to edit_lowBoundDA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hints: get(hObject,'String') returns contents of edit_lowBoundDA as text
%        str2double(get(hObject,'String')) returns contents of edit_lowBoundDA as a double

% delete previously calculated results if applicable
handles = deleteResults(handles,'ModelFcn');

input = str2double(strrep(get(hObject,'string'), ',', '.'));
default = 1;
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg('You must enter a positive real numeric value',...
        'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % set to default value
    set(hObject, 'string', num2str(default));
else
    set(hObject, 'string', num2str(input));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_lowBoundDA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_lowBoundDA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_lowBoundSigmaA_Callback(hObject, eventdata, handles)
% hObject    handle to edit_lowBoundSigmaA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hints: get(hObject,'String') returns contents of edit_lowBoundSigmaA as text
%        str2double(get(hObject,'String')) returns contents of edit_lowBoundSigmaA as a double

% delete previously calculated results if applicable
handles = deleteResults(handles,'ModelFcn');

input = str2double(strrep(get(hObject,'string'), ',', '.'));
default = .5;
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg('You must enter a positive real numeric value',...
        'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % set to default value
    set(hObject, 'string', num2str(default));
else
    set(hObject, 'string', num2str(input));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_lowBoundSigmaA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_lowBoundSigmaA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_lowBoundDC_Callback(hObject, eventdata, handles)
% hObject    handle to edit_lowBoundDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hints: get(hObject,'String') returns contents of edit_lowBoundDC as text
%        str2double(get(hObject,'String')) returns contents of edit_lowBoundDC as a double

% delete previously calculated results if applicable
handles = deleteResults(handles,'ModelFcn');

input = str2double(strrep(get(hObject,'string'), ',', '.'));
default = 1;
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg('You must enter a positive real numeric value',...
        'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % set to default value
    set(hObject, 'string', num2str(default));
else
    set(hObject, 'string', num2str(input));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_lowBoundDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_lowBoundDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_lowBoundSigmaC_Callback(hObject, eventdata, handles)
% hObject    handle to edit_lowBoundSigmaC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hints: get(hObject,'String') returns contents of edit_lowBoundSigmaC as text
%        str2double(get(hObject,'String')) returns contents of edit_lowBoundSigmaC as a double

% delete previously calculated results if applicable
handles = deleteResults(handles,'ModelFcn');

input = str2double(strrep(get(hObject,'string'), ',', '.'));
default = .5;
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg('You must enter a positive real numeric value',...
        'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % set to default value
    set(hObject, 'string', num2str(default));
else
    set(hObject, 'string', num2str(input));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_lowBoundSigmaC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_lowBoundSigmaC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_upBoundDA_Callback(hObject, eventdata, handles)
% hObject    handle to edit_upBoundDA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hints: get(hObject,'String') returns contents of edit_upBoundDA as text
%        str2double(get(hObject,'String')) returns contents of edit_upBoundDA as a double

% delete previously calculated results if applicable
handles = deleteResults(handles,'ModelFcn');

input = str2double(strrep(get(hObject,'string'), ',', '.'));
default = 20;
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg('You must enter a positive real numeric value',...
        'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % set to default value
    set(hObject, 'string', num2str(default));
else
    set(hObject, 'string', num2str(input));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_upBoundDA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_upBoundDA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_upBoundSigmaA_Callback(hObject, eventdata, handles)
% hObject    handle to edit_upBoundSigmaA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hints: get(hObject,'String') returns contents of edit_upBoundSigmaA as text
%        str2double(get(hObject,'String')) returns contents of edit_upBoundSigmaA as a double

% delete previously calculated results if applicable
handles = deleteResults(handles,'ModelFcn');

input = str2double(strrep(get(hObject,'string'), ',', '.'));
default = 15;
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg('You must enter a positive real numeric value',...
        'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % set to default value
    set(hObject, 'string', num2str(default));
else
    set(hObject, 'string', num2str(input));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_upBoundSigmaA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_upBoundSigmaA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_upBoundDC_Callback(hObject, eventdata, handles)
% hObject    handle to edit_upBoundDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hints: get(hObject,'String') returns contents of edit_upBoundDC as text
%        str2double(get(hObject,'String')) returns contents of edit_upBoundDC as a double

% delete previously calculated results if applicable
handles = deleteResults(handles,'ModelFcn');

input = str2double(strrep(get(hObject,'string'), ',', '.'));
default = 20;
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg('You must enter a positive real numeric value',...
        'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % set to default value
    set(hObject, 'string', num2str(default));
else
    set(hObject, 'string', num2str(input));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_upBoundDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_upBoundDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_upBoundSigmaC_Callback(hObject, eventdata, handles)
% hObject    handle to edit_upBoundSigmaC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hints: get(hObject,'String') returns contents of edit_upBoundSigmaC as text
%        str2double(get(hObject,'String')) returns contents of edit_upBoundSigmaC as a double

% delete previously calculated results if applicable
handles = deleteResults(handles,'ModelFcn');

input = str2double(strrep(get(hObject,'string'), ',', '.'));
default = 15;
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg('You must enter a positive real numeric value',...
        'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % set to default value
    set(hObject, 'string', num2str(default));
else
    set(hObject, 'String', num2str(input));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_upBoundSigmaC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_upBoundSigmaC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_stepSize_Callback(hObject, eventdata, handles)
% hObject    handle to edit_stepSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_stepSize as text
%        str2double(get(hObject,'String')) returns contents of edit_stepSize as a double

% delete previously calculated results if applicable
handles = deleteResults(handles,'ModelFcn');

input = str2double(strrep(get(hObject,'string'), ',', '.'));
default = 0.000016;
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg('You must enter a positive real numeric value',...
        'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % set to default value
    set(hObject, 'string', num2str(default));
else
    set(hObject, 'string', num2str(input));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_stepSize_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_stepSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_resolWidth_Callback(hObject, eventdata, handles)
% hObject    handle to edit_resolWidth (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% delete previously calculated results if applicable
handles = deleteResults(handles,'ModelFcn');

input = str2double(strrep(get(hObject,'string'), ',', '.'));
default = 0.000016;
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg('You must enter a positive real numeric value',...
        'Invalid Input','modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject)
    % set to default value
    set(hObject, 'string', num2str(default));
else
    set(hObject, 'string', num2str(input));
end
% Update handles structure
guidata(hObject, handles);
% --- Executes during object creation, after setting all properties.
function edit_resolWidth_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_resolWidth (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pb_fitModelFcn.
function pb_fitModelFcn_Callback(hObject, eventdata, handles)
% hObject    handle to pb_fitModelFcn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% delete previous results
set(handles.text_resultsModelFcnFit,'String', '')

% set pointer to show a sand watch in order to let the user know that the
% GUI is busy
set(handles.figure1, 'pointer', 'watch')
drawnow;

% get the parameters' starting values, lower and upper bound from the
% corresponding editable text boxes
handles.startValModelFcnFit = ...
        [str2double(get(handles.edit_startValSigmaA,'String')) ...
            str2double(get(handles.edit_startValSigmaC,'String')) ...
            str2double(get(handles.edit_startValDA,'String')) ...
            str2double(get(handles.edit_startValDC,'String')) ];
handles.lowBoundModelFcnFit = ...
        [str2double(get(handles.edit_lowBoundSigmaA,'String')) ...
            str2double(get(handles.edit_lowBoundSigmaC,'String')) ...
            str2double(get(handles.edit_lowBoundDA,'String')) ...
            str2double(get(handles.edit_lowBoundDC,'String')) ];
handles.upBoundModelFcnFit = ...
        [str2double(get(handles.edit_upBoundSigmaA,'String')) ...
            str2double(get(handles.edit_upBoundSigmaC,'String')) ...
            str2double(get(handles.edit_upBoundDA,'String')) ...
            str2double(get(handles.edit_upBoundDC,'String')) ];
handles.stepSizeModelFcnFit = str2double(get(handles.edit_stepSize,'String'));
handles.resolWidthModelFcnFit = str2double(get(handles.edit_resolWidth,'String'));

handles.scattVectHighResol = (0:handles.stepSizeModelFcnFit:handles.equidistScattVect(end))';
handles.PIs4HighResol = interp1(handles.equidistScattVect,handles.PIs4,...
                        handles.scattVectHighResol);
% flip and concatenate data 
scattVectMirrored = ...
    [-flipud(handles.equidistScattVect(2:end)); handles.equidistScattVect(1:end)];
PIs4Mirrored = [flipud(handles.PIs4(2:end)); handles.PIs4(1:end)];

% define function handle for the model function in order to pass additional 
% user specified or previously calculated parameters to the model function
fcn = @(param,s) modelFunction(param,s,handles.porodFitP, handles.sigma,...
                           handles.minDist, handles.resolWidthModelFcnFit);
                            
% the function lsqcurvefit() from the MATLAB Optimization toolbox is used
% to find a least-square fit of the model function to the data
%options=optimset('Display','off');% does not display output 
options=optimset('Display','notify', 'MaxFunEvals', 1200, 'MaxIter', 1200, 'TolFun', 1e-16, 'TolX', 1e-16);%displays output only if function does not converge
[handles.paramModelFcnFit,err]= ...
   lsqcurvefit(fcn, handles.startValModelFcnFit, ...
        scattVectMirrored , PIs4Mirrored ,...
        handles.lowBoundModelFcnFit, handles.upBoundModelFcnFit, options);
handles.errorNormModelFcnFit = sqrt(err);
%TODO: fr Konfidenzintervallberechnung:
%[handles.paramModelFcnFit,err,residual,exitflag,output,lambda,jacobian] =
%        lsqcurvefit(fcn, handles.startValModelFcnFit,scattVectMirrored,...
%        PIs4Mirrored ,handles.lowBoundModelFcnFit, handles.upBoundModelFcnFit, options);

% interpolation of the equidistant data in order to obtain a higher
% resolution
handles.scattVectHighResol = (0:handles.stepSizeModelFcnFit:...
                                handles.equidistScattVect(end))';
% flip and concatenate data 
scattVectHighResol =  [-flipud(handles.scattVectHighResol(2:end));...
                        handles.scattVectHighResol(1:end)];
% calculate the points of the fitted function (result is symmetric around
% zero)
modelFcnFit = modelFunction(handles.paramModelFcnFit,...
                       scattVectHighResol,handles.porodFitP, ...
                        handles.sigma, handles.minDist, handles.resolWidthModelFcnFit);
% use only second half of the resulting (points starting from z=0)                    
handles.modelFcnFit = modelFcnFit(floor(end/2)+1:end);
 % diplay results in the corresponding panel
precision = 12; % number of digits diplayed for each result
result = sprintf([' d_a = ' num2str(handles.paramModelFcnFit(3),precision)...
        '\n Sigma_a = ' num2str(handles.paramModelFcnFit(1),precision)...
        '\n d_c = ' num2str(handles.paramModelFcnFit(4),precision)...
        '\n Sigma_c = ' num2str(handles.paramModelFcnFit(2),precision)...
        '\n Error norm = ' num2str(handles.errorNormModelFcnFit,precision)]);
set(handles.text_resultsModelFcnFit,'String', result)

set(handles.pb_addModelFcnFit,'Enable','On')
% check whether K''(z) was already calculated, before enabling addFFTModelFit-button                                 
if( isfield(handles,'K2') ) 
    set(handles.pb_addFFTModelFit,'Enable','On')
end
% add plot to fitted function
pb_addModelFcnFit_Callback(hObject, eventdata, handles)
% Update handles structure
guidata(hObject, handles);  
% set pointer back to 'arrow' to indicate that the calculation is
% finished
set(handles.figure1, 'pointer', 'arrow')


% --- Executes on button press in pb_addModelFcnFit.
function pb_addModelFcnFit_Callback(hObject, eventdata, handles)
% hObject    handle to pb_addModelFcnFit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
plot(handles.equidistScattVect,zeros(1,length(handles.equidistScattVect)),...
    'b-','LineWidth',.1);
hold on
h1 = plot(handles.equidistScattVect,handles.PIs4 ,'k.-');
h2 = plot(handles.scattVectHighResol, handles.modelFcnFit,'r-'); 
legend([h1 , h2],{'Data','Fit'});
xlabel('s in nm^{-1}','fontsize',12,'fontweight','b')
ylabel(['16 pi^3 (P - (I-c2)*s^4 + c1*s^6) exp(- 4 pi^2 sigma^2 s^2)'...
    ' in e.u./nm^7'],'fontsize',12,'fontweight','b');
hold off
% set limits of the axes to be the same as for the model function plot
ylim(handles.PIs4PlotYLim);
xlim(handles.PIs4PlotXLim);
% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in pb_addFFTModelFit.
function pb_addFFTModelFit_Callback(hObject, eventdata, handles)
% hObject    handle to pb_addFFTModelFit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Set transform length to the next power of 2
nFFT = pow2(nextpow2(length(handles.modelFcnFit))+1);
% Perform discrete Fourier transformation of the right half of the fitted
% model function
% for the transformation the first point is divided by 2 (because it's a
% boundary point and MATLAB uses a midpoint method for the FFT)
transform = ...
        real(fft([handles.modelFcnFit(1)/2 ;handles.modelFcnFit(2:end)],nFFT)) ...
            * handles.stepSizeModelFcnFit;
% first half of the transform can be compared to the values of K''
% calculated previously
% moreover: subtract the scaled offset 
handles.transformedModelFcn = transform(1:end/2);               
handles.zValTransformedModelFcn = (1/handles.stepSizeModelFcnFit ...
                                    * linspace(0,1/2,nFFT/2))';

plot(handles.zValues,zeros(1,length(handles.zValues)),'b-','LineWidth',.1);
hold on
h1 = plot(handles.zValues,handles.K2,'k.-');
h2 = plot(handles.zValTransformedModelFcn, handles.transformedModelFcn,'r-');  
xlim([0 handles.zValues(end)]); 
hold off
legend([h1 ,h2],{'K''''(z)','transformed model function'});
xlabel('z  in  nm','fontsize',12,'fontweight','b')
ylabel('K''''(z)  in  nm^{-8}','fontsize',12,'fontweight','b');
% if all results have been calculated, enable save ALL button
if( isfield(handles,'Is2') && isfield(handles,'K') )
    set(handles.menu_saveAll,'Enable','on');
end
% Update handles structure
guidata(hObject, handles); 


% --------------------------------------------------------------------
function Menu_save_Callback(hObject, eventdata, handles)
% hObject    handle to Menu_save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function menu_saveAvailable_Callback(hObject, eventdata, handles)
% hObject    handle to menu_saveAvailable (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% open GUI to select the file path and file name where the results shall be
% saved
[handles.fileNameSave,handles.pathNameSave] = uiputfile({'*.*','All Files'},...
    'Save results',[handles.pathName, 'results_',handles.fileName]);

% check whether user has selected 'cancel' in the GUI, if yes do nothing 
if isequal(handles.fileNameSave,0) || isequal(handles.pathNameSave,0)
   return
else
   saveAvailable(handles);
end
% Update handles structure
guidata(hObject, handles)

% --------------------------------------------------------------------
function menu_saveAll_Callback(hObject, eventdata, handles)
% hObject    handle to menu_saveAll (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% open GUI to select the file path and file name where the results shall be
% saved
[handles.fileNameSave,handles.pathNameSave] = uiputfile({'*.*','All Files'},...
    'Save results',[handles.pathName, 'results_',handles.fileName]);

% check whether user has selected 'cancel' in the GUI, if yes do nothing 
if isequal(handles.fileNameSave,0) || isequal(handles.pathNameSave,0)
   return
else
   saveAll(handles);
end
% Update handles structure
guidata(hObject, handles); 
