%     This file is part of correlation_gui.
% 
%     correlation_gui is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     any later version.
% 
%     correlation_gui is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with correlation_gui.  If not, see <http://www.gnu.org/licenses/>.
% 
%     Diese Datei ist Teil von correlation_gui.
% 
%     correlation_gui ist Freie Software: Sie knnen es unter den Bedingungen
%     der GNU General Public License, wie von der Free Software Foundation,
%     Version 3 der Lizenz oder jeder neueren verffentlichten Version, 
%     weiter verteilen und/oder modifizieren.
% 
%     correlation_gui wird in der Hoffnung, dass es ntzlich sein wird, aber
%     OHNE JEDE GEWHRLEISTUNG, bereitgestellt; sogar ohne die implizite
%     Gewhrleistung der MARKTFHIGKEIT oder EIGNUNG FR EINEN BESTIMMTEN ZWECK.
%     Siehe die GNU General Public License fr weitere Details.
% 
%     Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
%     Programm erhalten haben. Wenn nicht, siehe <https://www.gnu.org/licenses/>.

function varargout = fileProperties_gui(varargin)
% FILEPROPERTIES_GUI MATLAB code for fileProperties_gui.fig
%      FILEPROPERTIES_GUI, by itself, creates a new FILEPROPERTIES_GUI or raises the existing
%      singleton*.
%
%      H = FILEPROPERTIES_GUI returns the handle to a new FILEPROPERTIES_GUI or the handle to
%      the existing singleton*.
%
%      FILEPROPERTIES_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FILEPROPERTIES_GUI.M with the given input arguments.
%
%      FILEPROPERTIES_GUI('Property','Value',...) creates a new FILEPROPERTIES_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before fileProperties_gui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to fileProperties_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help fileProperties_gui

% Last Modified by GUIDE v2.5 08-Mar-2022 09:51:11

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @fileProperties_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @fileProperties_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before fileProperties_gui is made visible.
function fileProperties_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to fileProperties_gui (see VARARGIN)

% Choose default command line output for fileProperties_gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes fileProperties_gui wait for user response (see UIRESUME)
 uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = fileProperties_gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
%close GUI
delete(hObject);

function edit_headerLines_Callback(hObject, eventdata, handles)
% hObject    handle to edit_headerLines (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_headerLines as text
%        str2double(get(hObject,'String')) returns contents of edit_headerLines as a double

input = str2double(get(hObject,'string'));
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg(strcat('You must enter a positive real numeric value!'),...
        'Invalid Input', 'modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject) 
    set(handles.edit_headerLines, 'String', '');
else
    % if a non-interger value was enter round it to the next integer
    set(handles.edit_headerLines, 'String', num2str(ceil(input)));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_headerLines_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_headerLines (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_delimiter_Callback(hObject, eventdata, handles)
% hObject    handle to edit_delimiter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_delimiter as text
%        str2double(get(hObject,'String')) returns contents of edit_delimiter as a double

input = get(hObject,'string');
% if (isempty(input))  
%     set(handles.edit_delimiter, 'String', ' ');
%     set(handles.text_delimiter, 'String', 'space');
% else
    % write input next to editable textbox (with space explicitely witten
    % as 'space') for the user to check his input
    text = '';
    for i = 1 : length(input)
        if (strcmp(input(i),' '))
            text = [text ' space '];
        else
            text  = [text input(i)];
        end
    end
    set(handles.text_delimiter, 'String', text);
% end

% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_delimiter_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_delimiter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function text_delimiter_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_delimiter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_colScattVect_Callback(hObject, eventdata, handles)
% hObject    handle to edit_colScattVect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_colScattVect as text
%        str2double(get(hObject,'String')) returns contents of edit_colScattVect as a double

input = str2double(get(hObject,'string'));
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg(strcat('You must enter a positive real numeric value!'),...
        'Invalid Input', 'modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject) 
    set(handles.edit_colScattVect, 'String', '');
else
    % if a non-interger value was enter round it to the next integer
    set(handles.edit_colScattVect, 'String', num2str(ceil(input)));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_colScattVect_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_colScattVect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_colAbsInt_Callback(hObject, eventdata, handles)
% hObject    handle to edit_colAbsInt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_colAbsInt as text
%        str2double(get(hObject,'String')) returns contents of edit_colAbsInt as a double

input = str2double(get(hObject,'string'));
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg(strcat('You must enter a positive real numeric value!'),...
        'Invalid Input', 'modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject) 
    set(handles.edit_colAbsInt, 'String', '');
else
    % if a non-interger value was enter round it to the next integer
    set(handles.edit_colAbsInt, 'String', num2str(ceil(input)));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_colAbsInt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_colAbsInt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_colError_Callback(hObject, eventdata, handles)
% hObject    handle to edit_colError (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_colError as text
%        str2double(get(hObject,'String')) returns contents of edit_colError as a double

input = str2double(get(hObject,'string'));
if (isnan(input) || input<0 || input==1i || input ==1j)
    h = errordlg(strcat('You must enter a positive real numeric value!'),...
        'Invalid Input', 'modal');
    uiwait(h)% wait until error dialog is closed, then continue
    uicontrol(hObject) 
    set(handles.edit_colError, 'String', '');
else
    % if a non-interger value was enter round it to the next integer
    set(handles.edit_colError, 'String', num2str(ceil(input)));
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_colError_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_colError (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pb_ok.
function pb_ok_Callback(hObject, eventdata, handles)
% hObject    handle to pb_ok (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% check whether all required inputs have been provided
if ( isempty(get(handles.edit_headerLines,'string')) )
    h = errordlg(strcat('Please enter the number of header lines!'),...
        'Invalid Input', 'modal');
    uiwait(h)% wait until error dialog is closed, then continue
    return
elseif ( isempty(get(handles.edit_colScattVect,'string')) )
    h = errordlg(strcat(['Please enter the column number of the scatter'...
        ' vectors!']), 'Invalid Input', 'modal');
    uiwait(h)% wait until error dialog is closed, then continue
    return
elseif ( isempty(get(handles.edit_colAbsInt,'string')) )
    h = errordlg(strcat(['Please enter the column number of the absolute'...
        ' intensities!']), 'Invalid Input', 'modal');
    uiwait(h)% wait until error dialog is closed, then continue
    return
end

if (get(handles.qCheckBox,'Value') == 1) % scattering vector in q
    handles.output.scattVectType = 'q';
else % scattering vector in s
    handles.output.scattVectType = 's';
end

if (get(handles.AngstromCheckBox,'Value') == 1) % scattering vector in Angstrom
    handles.output.scattVectUnit = 'Angstrom';
else % scattering vector in nm
    handles.output.scattVectUnit = 'nm';
end

handles.output.nHeaderLines = str2double(get(handles.edit_headerLines,'string'));
handles.output.delimiter = get(handles.edit_delimiter,'string');
handles.output.colScattVect = str2double(get(handles.edit_colScattVect,'string'));
handles.output.colAbsInt = str2double(get(handles.edit_colAbsInt,'string'));
%if colError is empty, str2doulbe() returns NaN
handles.output.colError = str2double(get(handles.edit_colError,'string'));
% Update handles structure
guidata(hObject, handles);
% close GUI -> resume the program execution that uiwait suspended (in
% fileProperties_gui_OpeningFcn())
uiresume(gcf)


% --- Executes on button press in qCheckBox.
function qCheckBox_Callback(hObject, eventdata, handles)
% hObject    handle to qCheckBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of qCheckBox


% --- Executes on button press in AngstromCheckBox.
function AngstromCheckBox_Callback(hObject, eventdata, handles)
% hObject    handle to AngstromCheckBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of AngstromCheckBox
